
#pragma once

//#include <limits>

namespace hype{

	enum ComputeDevice {CPU,GPU,FPGA,NP}; //CPU,GPU,FPGA, Network Processor

	enum DeviceConstraint{ANY_DEVICE,CPU_ONLY,GPU_ONLY,FPGA_ONLY,NP_ONLY}; //ALL,CPU,GPU,FPGA, Network Processor
	
	enum Architecture{Architecture_32Bit,Architecture_64Bit};
	
	struct StatisticalMethods{
		enum StatisticalMethod{
			Least_Squares_1D,
			Multilinear_Fitting_2D
		};
	};
	
	struct RecomputationHeuristics{
		enum RecomputationHeuristic{
			No_Recomputation,
			Periodic,
			RelativeErrorBased
		};
	};
	
	struct OptimizationCriterions{
		enum OptimizationCriterion{
			ResponseTime,
			Throughput_Simple_Round_Robin
		};
	};
	
	namespace core{

/*	
	enum DebugMode{quiet=0,
					   verbose=1,
					   debug=1,
					   print_time_measurement=0};//*/

/*
	enum DebugMode{quiet=0,
					   verbose=1,
					   debug=1,
					   print_time_measurement=0};//*/

///*
	enum DebugMode{quiet=1,
					   verbose=0,
					   debug=0,
					   print_time_measurement=0};//*/

//	struct Configuration{

//		static const unsigned int length_of_initial_training_phase=200; //200; //length in number of samples
//		static const unsigned int length_of_history=1000; //for statistical methods, length in number of samples

//		static const unsigned int period_for_periodic_recomputation=100; //200;		
//		static const double threshold_for_relative_error_based_recomputation=2.0;	

//		static const unsigned int maximal_time_where_algorithm_was_not_choosen=1000;	//after this time, retrain algorithm
//		static const unsigned int maximal_retraining_length=10;

//		//statistics
//		static const unsigned int window_size_for_windowed_average_relative_estimation_error=100; //take last x relative errors and compute average

//	};

	//#define DUMP_ESTIMATIONS
		
	/*	
	struct Configuration{
 
		static const unsigned int length_of_initial_training_phase=10; //100;  //10; //200; //length in number of samples
		static const unsigned int length_of_history=1000; //for statistical methods, length in number of samples

		static const unsigned int period_for_periodic_recomputation=100; //200;		
		static const double threshold_for_relative_error_based_recomputation=2.0;	

		static const unsigned int maximal_time_where_algorithm_was_not_choosen=8;	//after this time, retrain algorithm
		static const unsigned int maximal_retraining_length=1;

		//statistics
		static const unsigned int window_size_for_windowed_average_relative_estimation_error=100; //take last x relative errors and compute average
		static const double outliner_threshold_in_percent=1000; //if relative error is above this value, then ignore measurement pair
				

	};
	*/
	


	};//end namespace core
}; //end namespace stemod


