
#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <tr1/memory>

#include <core/optimization_criterion.hpp>
#include <core/time_measurement.hpp>

namespace hype{
	namespace core{


class Throughput2 : public OptimizationCriterion{

	public:
	Throughput2(std::string name_of_operation);

	virtual const SchedulingDecision getOptimalAlgorithm_internal(const Tuple& input_values, Operation& op, DeviceConstraint dev_constr);
//OptimizationCriterionFactorySingleton::Instance().

	static Throughput2* create(){
		return new Throughput2("");
	}

};


	}; //end namespace core
}; //end namespace stemod



