#pragma once

#include <string>
#include <stdexcept>

namespace hype
{
	namespace core{

		class Report
		{	public:
			static Report& instance();
			
			double getRelativeEstimationError(const std::string& algorithm_name) const throw(std::invalid_argument);
			
			private:
				Report();
				Report(const Report& report);
				Report& operator=(const Report& report);
		};

	};//end namespace core
}; //end namespace stemod	

