
#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <tr1/memory>

#include <core/optimization_criterion.hpp>
#include <core/time_measurement.hpp>

namespace hype{
	namespace core{


class ResponseTime : public OptimizationCriterion{

	public:
	ResponseTime(const std::string& name_of_operation);

	virtual const SchedulingDecision getOptimalAlgorithm_internal(const Tuple& input_values, Operation& op, DeviceConstraint dev_constr);
//OptimizationCriterionFactorySingleton::Instance().

	static ResponseTime* create(){
		return new ResponseTime("");
	}

};


	}; //end namespace core
}; //end namespace stemod



